# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   momth8_day7_bpm_final
# FileName:      test_case.py
# Author:       李浩东
# Datetime:     2023/8/7 20:04
# Description:
# 
# ---------------------------------------------------------------------------
import allure
import pytest
from BPM_common.read_excel import READ_EXCEL


class TestBPM:
    @allure.epic("BPM系统")
    @pytest.mark.parametrize(
        "module_name,interface_name,title_name,case_level,request_method,request_url,request_mime,case_data,expect_data,sql_type,sql_statement,update_key",
        READ_EXCEL().all_data())
    def test_bpm(self, request_fixture, db_fixture,module_name,interface_name,title_name,case_level,request_method,request_url,request_mime,case_data,expect_data,sql_type,sql_statement,update_key):
        allure.dynamic.feature(module_name)
        allure.dynamic.story(interface_name)
        allure.dynamic.title(case_level)
        if sql_type=="select":
            select_result = db_fixture.select(sql_statement)
            case_data[update_key] = select_result
            result = request_fixture.request_all(method=request_method, url=request_url, mime=request_mime, case_data=case_data)

        elif sql_type=="select|delete" or sql_type == "delete|select":
            db_fixture.delete(sql_statement["delete"])
            select_result = db_fixture.select(sql_statement["select"])
            case_data[update_key] = select_result
            result = request_fixture.request_all(method=request_method, url=request_url, mime=request_mime, case_data=case_data)

        elif sql_type=="delete":
            db_fixture.delete(sql_statement)
            result = request_fixture.request_all(method=request_method, url=request_url, mime=request_mime, case_data=case_data)

        else:
            result = request_fixture.request_all(method=request_method, url=request_url, mime=request_mime, case_data=case_data)

        print("=" * 100)
        print("服务器返回数据", result.json())

        try:
            for key in expect_data.keys():
                assert expect_data[key] == result.json().get(key)
        except:
            raise AttributeError("断言失败")
        else:
            print("断言成功")

if __name__ == '__main__':
    pytest.main()