# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   momth8_day7_bpm_final
# FileName:      request_method.py
# Author:       李浩东
# Datetime:     2023/8/7 19:43
# Description:
# 
# ---------------------------------------------------------------------------
import base64

import requests

from BPM_common.read_ini import READ_INI


class REQUEST_METHOD:
    def __init__(self):
        host=READ_INI().get_host("BPM_host")
        login_url=host+"/auth"
        login_data={"username":"admin","password":base64.b64encode("123456".encode("utf-8")).decode("utf-8")}
        self.bpm_session=requests.sessions.Session()
        bpm_requests = self.bpm_session.request(method="post", url=login_url, json=login_data)
        token = bpm_requests.json().get("token")
        self.bpm_session.headers["Authorization"] = "Bearer " + token

    def request_all(self,method,url,mime,case_data):
        if mime=="application/x-www-form-urlencoded" or mime=="x-www-form-urlencoded" or mime=="form":
            return self.bpm_session.request(method=method, url=url, data=case_data)
        elif mime=="application/json" or mime=="json":
            return self.bpm_session.request(method=method,url=url,json=case_data)
        elif mime=="multipart/form-data" or mime=="form-data" or mime=="file":
            return self.bpm_session.request(method=method,url=url,files=case_data)
        elif mime == "query" or mime == "params":
            return self.bpm_session.request(method=method, url=url, params=case_data)
        elif mime == "text/plain" or mime == "text":
            return self.bpm_session.request(method=method, url=url, data=case_data)
        elif mime == "application/Json|query" or mime == "json|query" or mime=="application/json|query":
            return self.bpm_session.request(method=method, url=url, params=case_data["query"], json=case_data["body"])
        elif mime is None:
            return self.bpm_session.request(method=method, url=url)
        else:
            raise NameError("媒体类型的值错误")